''
'' Major functionality
''
'' 1. Application can pass into Init a configuration table. The configuration table is 32 word entries. 1 per
'' pin, each entry contains a device type from the enum below
'' 2. Applications should call config.GetPin(DeviceType) to get the pin for the device. GetPin will return -1 if
'' the device is not supported in the configuration table.
''
CON
'standard pin definitions
'enumeration of standard devices
' Just add new devices to the end of the list
#0, NOT_USED
KEYBOARD1_DATA                                                                  'Primary keyboard
KEYBOARD1_CLK                                                                   'Primary keyboard
MOUSE1_DATA                                                                     'Primary mouse
MOUSE1_CLK                                                                      'Primary mouse
TV_DAC1                                                                         'Primary TV
VGA1                                                                            'Primary VGA
AUDIO1,AUDIO2                                                                   'Primary/Secondary Audio
FSRW1_DO,FSRW1_CLK,FSRW1_DI,FSRW1_CS                                            'Primary SD media connections
DS1302_INCLK,DS1302_INIO,DS1302_CS                                              'DS1302 clock
DEBUG_TX,DEBUG_RX                                                               'serial debug serial port
GPS_TX,GPS_RX                                                                   'serial gps serial port
CMUCAM_TX,CMUCAM_RX                                                             'cmucam serial port
XBEE_TX,XBEE_RX                                                                 'XBBE serial port
HYDRANET_TX,HYDRANET_RX                                                         'HYDRA Net
IRDETECT,IREMIT                                                                 'IR Emit/detect
PING_DATA                                                                       'Ping Sensor
JOY_CLK,JOY_SHLDN,JOY_DATAOUT0,JOY_DATAOUT1                                     'Nes controller configuration
PG_RXPIN,PG_TXPIN                                                               'PropGFX Lite configuration
DEBUG_LED1,DEBUG_LED2,DEBUG_LED3                                                'some leds for debugging
ENC1_SCK,ENC1_SI,ENC1_SO,ENC1_INT                                               'ENC28J60 Ethernet
HM55BEna,HM55BClk,HM55BDI,HM55BDO                                               'HM55B compass
I2C_SCL1, I2C_SDA1                                                              'primary I2C
I2C_SCL2, I2C_SDA2                                                              'secondary I2C
SERVO1, SERVO2, SERVO3,SERVO4                                                   'servos
SERVO5, SERVO6, SERVO7,SERVO8                                                   'servos
SERVO9, SERVO10, SERVO11,SERVO12                                                'servos
SERVO13, SERVO14, SERVO15,SERVO16                                               'servos
HB25_1,HB25_2,HB25_3,HB25_4                                                     'motor controllers
QE_1,QE_2,QE_3,QE_4                                                             'Quad encoder
QE_5,QE_6,QE_7,QE_8                                                             'Quad encoder
QE_9,QE_10,QE_11,QE_12                                                          'Quad encoder
QE_13,QE_14,QE_15,QE_16                                                         'Quad encoder
VEXDEMUX                                                                        'VEX RC receiver
HX512_C0,HX512_C1,HX512_CLK,HX512_RST,HX512_DATA                                'Hydra 512k expansion sram

''
'' Used to define a list of non-standard devices. These are defined at $8000 or above
'' so they do not conflict with standard devices
''
#$8000
SOUNDGIN_TX,SOUNDGIN_CTS                                                        'sound serial port

IPR_TX,IPR_RX                                                                   'Inter-Prop Ring

TOV6620_DATA,TOV6620_PWDN,TOV6620_RST,TFIFO_RST                                 'Common camera 1/2 configuration
TFIFO_WRST1,TFIFO_RRST1,TFIFO_RCK1,TFIFO_OE1,TFIFO_WEE1,TFIFO_HREF1,TFIFO_VSYN1 'Camera 1 configuration - also uses I2C_SCL1/I2C_SDA1
TFIFO_WRST2,TFIFO_RRST2,TFIFO_RCK2,TFIFO_OE2,TFIFO_WEE2,TFIFO_HREF2,TFIFO_VSYN2 'Camera 2 configuration - also uses I2C_SCL/IC2_SDA

FPU_MCLR                                                                        'FPU reset

GPS_RX2,GPS_TX2                                                                 'secondary gps port

TLC5940_SCLK,TLC5940_SIN,TLC5940_XLAT,TLC5940_GSCLK,TLC5940_BLANK,TLC5940_VPRG  'TLC5940 LED painter
TLC5940_SOUT,TLC5940_DCPRG

THEREMIN_CLK,THEREMIN_E1,THEREMIN_C1,THEREMIN_E2,THEREMIN_C2                    'Theremin sensor
THEREMIN_E3,THEREMIN_C3,THEREMIN_E4,THEREMIN_C4

TIME_CLK

DAT
  PINS  LONG  0                                         'DAT so available to all COGs
  
PUB Init(addr)                                          'Save configuration table address
  PINS := addr                                          
    
PUB GetPin(PinType)                                     'Find pin for this device type
  repeat result from 0 to 31
    if word[PINS][result] == PinType
      return
  return -1